Skip site navigation (1)Skip section navigation (2)
Date:      Sun, 28 Sep 2014 01:45:20 +0000 (UTC)
From:      Glen Barber <gjb@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-projects@freebsd.org
Subject:   svn commit: r272234 - in projects/release-vmimage/release: . scripts
Message-ID:  <201409280145.s8S1jKGq009589@svn.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: gjb
Date: Sun Sep 28 01:45:20 2014
New Revision: 272234
URL: http://svnweb.freebsd.org/changeset/base/272234

Log:
  Initial commit to include virtual machine images as part
  of the FreeBSD release builds.
  
  This adds a make(1) environment variable requirement,
  WITH_VMIMAGES, which triggers the virtual machine image
  targets when not defined to an empty value.
  
  Relevant user-driven variables include:
  
   o VMFORMATS:	The virtual machine image formats to create.
     Valid formats are provided by running 'mkimg --formats'
  
   o VMSIZE:	The size of the resulting virtual machine
     image.  Typical compression is roughly 140Mb, regardless
     of the target size (10GB, 15GB, 20GB, 40GB sizes have been
     tested with the same result).
  
   o VMBASE:	The prefix of the virtual machine disk images.
     The VMBASE make(1) environment variable is suffixed with
     each format in VMFORMATS for each individual disk image, as
     well as '.img' for the source UFS filesystem passed to
     mkimg(1).
  
  This also includes a new script, mk-vmimage.sh, based on how
  the VM images for 10.0-RELEASE, 9.3-RELEASE, and 10.1-RELEASE
  were created (mk-vmimage.sh in ^/user/gjb/thermite/).
  
  With the order in which the stages need to occur, as well as
  sanity-checking error cases, it makes much more sense to
  execute a shell script called from make(1), using env(1) to
  set specific parameters for the target image than it does to
  do this in make(1) directly.
  
  Sponsored by:	The FreeBSD Foundation

Added:
  projects/release-vmimage/release/scripts/mk-vmimage.sh   (contents, props changed)
Modified:
  projects/release-vmimage/release/Makefile

Modified: projects/release-vmimage/release/Makefile
==============================================================================
--- projects/release-vmimage/release/Makefile	Sun Sep 28 00:43:04 2014	(r272233)
+++ projects/release-vmimage/release/Makefile	Sun Sep 28 01:45:20 2014	(r272234)
@@ -23,6 +23,7 @@
 #  WITH_DVD: if set, generate dvd1.iso
 #  WITH_COMPRESSED_IMAGES: if set, compress installation images with xz(1)
 #		(uncompressed images are not removed)
+#  WITH_VMIMAGES: if set, build virtual machine images with the release
 #  TARGET/TARGET_ARCH: architecture of built release
 #
 
@@ -94,6 +95,11 @@ IMAGES+=	memstick.img
 IMAGES+=	mini-memstick.img
 .endif
 
+VMTARGETS=	vm-base vm-image
+VMFORMATS?=	vhd vmdk qcow2 raw
+VMSIZE?=	20G		# size in Gb
+VMBASE?=	vm		# name of the filesystem image
+
 CLEANFILES=	packagesystem *.txz MANIFEST system ${IMAGES}
 .if defined(WITH_COMPRESSED_IMAGES) && !empty(WITH_COMPRESSED_IMAGES)
 . for I in ${IMAGES}
@@ -103,7 +109,16 @@ CLEANFILES+=	${I}.xz
 .if defined(WITH_DVD) && !empty(WITH_DVD)
 CLEANFILES+=	pkg-stage
 .endif
+.if defined(WITH_VMIMAGES) && !empty(WITH_VMIMAGES)
+CLEANFILES+=	${VMBASE}.img
+. for FORMAT in ${VMFORMATS}
+CLEANFILES+=	vm.${FORMAT}
+. endfor
+.endif
 CLEANDIRS=	dist ftp release bootonly dvd
+.if defined(WITH_VMIMAGES) && !empty(WITH_VMIMAGES)
+CLEANDIRS+=	${VMTARGETS}
+.endif
 beforeclean:
 	chflags -R noschg .
 .include <bsd.obj.mk>
@@ -277,3 +292,41 @@ install:
 .endfor
 	cd ${DESTDIR} && sha256 ${OSRELEASE}* > ${DESTDIR}/CHECKSUM.SHA256
 	cd ${DESTDIR} && md5 ${OSRELEASE}* > ${DESTDIR}/CHECKSUM.MD5
+.if defined(WITH_VMIMAGES) && !empty(WITH_VMIMAGES)
+	mkdir -p ${DESTDIR}/vmimages
+. for FORMAT in ${VMFORMATS}
+	cp -p ${VMBASE}.${FORMAT} \
+		${DESTDIR}/vmimages/${OSRELEASE}.${FORMAT}
+. endfor
+. if defined(WITH_COMPRESSED_IMAGES) && !empty(WITH_COMPRESSED_IMAGES)
+# This is very time consuming, so defer it after the images are moved to
+# the DESTDIR.
+.  for FORMAT in ${VMFORMATS}
+	# Don't keep the originals.  There is a copy in ${.OBJDIR} if needed.
+	${XZCMD} ${DESTDIR}/vmimages/${OSRELEASE}.${FORMAT}
+.  endfor
+. endif
+	cd ${DESTDIR}/vmimages && sha256 ${OSRELEASE}* > \
+		${DESTDIR}/vmimages/CHECKSUM.SHA256
+	cd ${DESTDIR}/vmimages && md5 ${OSRELEASE}* > \
+		${DESTDIR}/vmimages/CHECKSUM.MD5
+.endif
+
+vm-base:
+.if defined(WITH_VMIMAGES) && !empty(WITH_VMIMAGES)
+	env IMAKE=${IMAKE} WORLDDIR=${WORLDDIR} \
+		VMBASE=${VMBASE}.img VMSIZE=${VMSIZE} DESTDIR=${.TARGET} \
+		TARGET=${TARGET} TARGET_ARCH=${TARGET_ARCH} \
+		${.CURDIR}/scripts/mk-vmimage.sh ${.TARGET}
+.endif
+	touch ${.TARGET}
+
+vm-image: vm-base
+.if defined(WITH_VMIMAGES) && !empty(WITH_VMIMAGES)
+. for FORMAT in ${VMFORMATS}
+	env FORMAT=${FORMAT} VMIMAGE=${VMBASE}.${FORMAT} VMBASE=${VMBASE}.img \
+		TARGET=${TARGET} TARGET_ARCH=${TARGET_ARCH} \
+		${.CURDIR}/scripts/mk-vmimage.sh ${.TARGET}
+. endfor
+.endif
+	touch ${.TARGET}

Added: projects/release-vmimage/release/scripts/mk-vmimage.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ projects/release-vmimage/release/scripts/mk-vmimage.sh	Sun Sep 28 01:45:20 2014	(r272234)
@@ -0,0 +1,157 @@
+#!/bin/sh
+#-
+# Copyright (c) 2014 The FreeBSD Foundation
+# All rights reserved.
+#
+# This software was developed by Glen Barber under sponsorship
+# from the FreeBSD Foundation.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# mk-vmimage.sh: Create virtual machine disk images in various formats.
+#
+# $FreeBSD$
+#
+
+PATH="/bin:/usr/bin:/sbin:/usr/sbin"
+export PATH
+
+usage() {
+	echo "$(basename ${0}) <command> <target> [...]"
+	if [ -z "${MAKEFLAGS}" ]; then
+		echo "It is probably not safe to run this by hand yet..."
+	fi
+	exit 1
+}
+
+panic() {
+	rc="${1}"
+	shift 1
+	msg="${@}"
+	printf "${msg}\n"
+	if [ ! -z "${mddev}" ]; then
+		mdconfig -d -u ${mddev}
+	fi
+	# Do not allow one failure case to chain through any remaining image
+	# builds.
+	exit 0
+}
+
+vm_create_baseimage() {
+	# Creates the UFS root filesystem for the virtual machine disk,
+	# written to the formatted disk image with mkimg(1).
+	i=0
+	mkdir -p ${DESTDIR}
+	truncate -s ${VMSIZE} ${VMBASE}
+	mddev=$(mdconfig -f ${VMBASE})
+	newfs -L root -j ${mddev}
+	mount ${mddev} ${DESTDIR}
+	cd ${WORLDDIR} && \
+		${IMAKE} DESTDIR=${DESTDIR} \
+		installworld installkernel distribution || \
+		panic 1 "\n\nCannot install the base system to ${DESTDIR}."
+	chroot ${DESTDIR} /usr/bin/newaliases
+	echo '# Custom /etc/fstab for FreeBSD VM images' \
+		# > ${DESTDIR}/etc/fstab
+	echo '/dev/gpt/rootfs	/	ufs	rw	2	2' \
+		# >> ${DESTDIR}/etc/fstab
+	echo '/dev/gpt/swapfs	none	swap	sw	0	0' \
+		# >> ${DESTDIR}/etc/fstab
+	sync
+	while ! umount ${DESTDIR}; do
+		i=$(( $i + 1 ))
+		if [ $i -ge 10 ]; then
+			# This should never happen.  But, it has happened.
+			msg="Cannot umount(8) ${DESTDIR}\n"
+			msg="${msg}Something has gone horribly wrong."
+			panic 1 "${msg}"
+		fi
+		sleep 1
+	done
+
+	return 0
+}
+
+vm_create_vmdisk() {
+	mkimg_version=$(mkimg --version 2>/dev/null | awk '{print $2}')
+
+	# We need mkimg(1) '--version' output, at minimum, to be able to
+	# tell what virtual machine disk image formats are available.
+	# Bail if mkimg(1) reports an empty '--version' value.
+	if [ -z "${mkimg_version}" ]; then
+		msg="Cannot determine mkimg(1) version.\n"
+		msg="${msg}Cannot continue without a known mkimg(1) version."
+		panic 0 "${msg}"
+	fi
+
+	if ! mkimg --formats 2>/dev/null | grep -q ${FORMAT}; then
+		panic 0 "Format ${FORMAT} is not supported with this mkimg(1)\n"
+	fi
+
+	case ${FORMAT} in
+		vhd)
+			mkimg_format=vhdf
+			;;
+		*)
+			mkimg_format=${FORMAT}
+			;;
+	esac
+
+	set -x
+	mkimg -f ${mkimg_format} -s gpt \
+		-b /boot/pmbr -p freebsd-boot/bootfs:=/boot/gptboot \
+		-p freebsd-swap/swapfs::1G \
+		-p freebsd-ufs/rootfs:=${VMBASE} \
+		-o ${VMIMAGE}
+
+	return 0
+}
+
+main() {
+	cmd="${1}"
+
+	case ${TARGET}/${TARGET_ARCH} in
+		amd64/amd64|i386/i386)
+			# FALLTHROUGH
+			;;
+		*)
+			# EX_CANTCREAT
+			return 0
+			;;
+	esac
+
+	case ${cmd} in
+		vm-base)
+			eval vm_create_baseimage "$@" || return 0
+			;;
+		vm-image)
+			eval vm_create_vmdisk "$@" || return 0
+			;;
+		*|\?)
+			usage
+			;;
+	esac
+
+	return 0
+}
+
+main "$@"



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?201409280145.s8S1jKGq009589>